;---     8048 -----

 .equ temp_buf1, 030h ;  buffer  NEWL
 .equ temp_buf2, 031h ;  buffer  BOXH
 .equ temp_buf3, 032h ;  buffer  BOXL

; reset vector
 .org  0
start:
  dis   i ; disable interrupts
  jmp  main

; external interrupt vector
 .org  3
intr:
  jmp  intr   ;

; timer interrupt vector
 .org  7
time:
  jmp  time   ;

main:
  mov  a,#5BH
  mov  r0,#temp_buf1 ; NEWL
  mov  @r0,a  ; .  
K04:
  mov  r0,#0  ;   1   D
  mov  r1,#0  ;  o 2  B
K05:
  call GETIT
  dec  a
  jz   DEL2

  mov  a,r6   ;   1
  orl  a,#0
  jz   K07

  mov  a,r0   ; .r0
  mov  r7,a   ;  2

  mov  r0,#temp_buf3 ; BOXL
  mov  a,r6   ;   1
  mov  @r0,a  ; .  

  mov  a,r7   ;    2
  mov  r0,a   ; .r0

  mov  a,r6   ;   1
  call PLAY   ;---
  inc  r0     ; D
K06:
  inc  r1     ; B
  call DEL1
  jmp  K05

K07:
   call DEL1
   jmp  main
;---  -    8048
  mov  a,r0   ; .r0
  mov  r7,a   ;  2

  mov  r0,#temp_buf3 ; BOXL
  mov  a,#03H ;
  mov  @r0,a  ; .  

  mov  r0,#temp_buf2 ; BOXH
  mov  a,#0FFH;
  mov  r6,a   ; .  1
  mov  @r0,a  ; .  

  mov  a,r7   ;    2
  mov  r0,a   ; .r0

  mov  a,r6   ;   1
  call PLAY   ;---
LOOP:
  mov  a,r0   ; .r0
  mov  r7,a   ;  2

  mov  r0,#temp_buf1 ; NEWL
  mov  a,@r0  ;   a
  mov  r0,#temp_buf2 ; BOXH
  mov  @r0,a  ; .  

  call PLAY   ;---

  mov  r0,#temp_buf1 ; NEWL
  mov  a,@r0  ;   a
  mov  r6,a   ; .  1
  dec  a
  mov  @r0,a  ; .  

  mov  a,r7   ;    2
  mov  r0,a   ; .r0

  mov  a,r6   ;   1
  dec  a
  jnz  LOOP
  jmp  main

DEL1:
  mov  r6,a   ; .  1
  clr  a
  mov  r5,a
  mov  a,#07H
  mov  r4,a
DE9:
  nop
  djnz r5,DE9
  nop
  djnz r4,DE9
  mov  a,r6   ;   1
  ret

DEL2:
  mov  r6,a   ; .  1
  clr  a
  mov  r3,a
  mov  a,#10H
  mov  r2,a
DEB:
  nop
  djnz r3,DEB
  nop
  djnz r2,DEB
  mov  a,r6   ;   1
  jmp  K06

PLAY:
  mov  r6,a   ; .  1

  mov  a,r0   ; .r0
  mov  r7,a   ;  2

  mov  r0,#temp_buf2 ; BOXH
  mov  a,@r0  ;   a
  mov  r5,a   ; counter

PL1:
  mov  a,#30H ;
  outl p1,a   ;    1
  call DEL3
  mov  a,#0C0H;
  outl p1,a   ;    1
  call DEL3
  djnz r5,PL1

  mov  a,r7   ;    2
  mov  r0,a   ; .r0

  mov  a,r6   ;   1
  ret

DEL3:
  mov  r0,#temp_buf3 ; BOXL
  mov  a,@r0  ;   a
  mov  r4,a   ; counter
DL1:
  nop
  djnz r4,DL1
  ret

 .org  100H
GETIT:
  mov  a,r0   ;   TAB2
  add  a,#TAB2-256;  TAB2
  movp a,@a   ; Move from memory TAB2 A=[PC<11:8>+A]

  outl p2,a

  mov  r6,a   ; .  1
  mov  a,r0   ; .r0
  mov  r7,a   ;  2
  mov  r0,#temp_buf2 ; BOXH
  mov  a,r6   ;   1
  mov  @r0,a  ; .  
  mov  a,r7   ;    2
  mov  r0,a   ; .r0

  mov  a,r1   ;   TAB1
  add  a,#TAB1-256;  TAB1
  movp a,@a   ; Move from memory TAB1 A=[PC<11:8>+A]

  outl p2,a

  mov  r6,a   ; .  1
  ret

TAB1:
  .DB  #5BH
  .DB  #01H
  .DB  #62H
  .DB  #01H
  .DB  #69H
  .DB  #62H
  .DB  #69H
  .DB  #6EH
  .DB  #76H
  .DB  #01H
  .DB  #7DH
  .DB  #01H
  .DB  #84H
  .DB  #01H
  .DB  #7DH
  .DB  #01H
  .DB  #01H
  .DB  #6EH
  .DB  #01H
  .DB  #76H
  .DB  #01H
  .DB  #7DH
  .DB  #76H
  .DB  #7DH
  .DB  #84H
  .DB  #8CH
  .DB  #01H
  .DB  #94H
  .DB  #01H
  .DB  #9EH
  .DB  #01H
  .DB  #94H
  .DB  #01H
  .DB  #01H
  .DB  #7DH
  .DB  #01H
  .DB  #0A6H
  .DB  #0A6H
  .DB  #0B0H
  .DB  #01H
  .DB  #0A6H
  .DB  #01H
  .DB  #01H
  .DB  #7DH
  .DB  #01H
  .DB  #0A6H
  .DB  #0A6H
  .DB  #0B0H
  .DB  #01H
  .DB  #0A6H
  .DB  #01H
  .DB  #0D0H
  .DB  #0C9H
  .DB  #0BEH
  .DB  #0B0H
  .DB  #0A6H
  .DB  #9EH
  .DB  #94H
  .DB  #8CH
  .DB  #84H
  .DB  #7DH
  .DB  #76H
  .DB  #6EH
  .DB  #69H
  .DB  #01H
  .DB  #01H
  .DB  #62H
  .DB  #01H
  .DB  #01H
  .DB  #00H

TAB2:
  .DB  #80H
  .DB  #70H
  .DB  #40H
  .DB  #40H
  .DB  #40H
  .DB  #40H
  .DB  #60H
  .DB  #60H
  .DB  #50H
  .DB  #50H
  .DB  #67H
  .DB  #67H
  .DB  #30H
  .DB  #30H
  .DB  #30H
  .DB  #30H
  .DB  #50H
  .DB  #50H
  .DB  #40H
  .DB  #40H
  .DB  #60H
  .DB  #20H
  .DB  #30H
  .DB  #50H
  .DB  #30H
  .DB  #60H
  .DB  #20H
  .DB  #30H
  .DB  #50H
  .DB  #30H
  .DB  #20H
  .DB  #20H
  .DB  #20H
  .DB  #28H
  .DB  #28H
  .DB  #28H
  .DB  #30H
  .DB  #30H
  .DB  #30H
  .DB  #30H
  .DB  #30H
  .DB  #30H
  .DB  #70H
  .DB  #90H
  .DB  #0E0H
  .DB  #00H
  .DB  #00H
  .DB  #00H
  .DB  #00H
  .DB  #00H
  .DB  #00H
  .DB  #00H
  .DB  #00H
  .DB  #00H
  .DB  #00H
  .DB  #00H
  .DB  #00H
  .DB  #00H
  .DB  #00H
  .DB  #00H
  .DB  #00H
  .DB  #00H
  .DB  #00H
  .DB  #00H
  .DB  #00H
  .DB  #00H
  .DB  #00H
  .DB  #00H
  .DB  #00H
  .DB  #00H
  .DB  #00H
  .DB  #00H
  .DB  #00H
  .DB  #00H
  .DB  #00H
  .DB  #00H
  .DB  #00H
  .DB  #00H
  .DB  #00H
  .DB  #00H
  .DB  #00H
  .DB  #00H
  .DB  #00H
  .DB  #00H
  .DB  #00H
  .DB  #00H
  .DB  #00H
  .DB  #00H
  .DB  #00H
  .DB  #00H
  .DB  #00H
  .DB  #00H
  .DB  #00H
  .DB  #00H
  .DB  #00H
  .DB  #00H
  .DB  #00H
  .DB  #00H
  .DB  #00H
  .DB  #00H

